#include "MainComponent.h"

//==============================================================================
MainComponent::MainComponent() :
dropShadow(juce::DropShadow(juce::Colours::black, 40, juce::Point<int>(0,0)))
{
    setSize (600, 400);
    
    createCompButton.setButtonText("Create Component 1 With Shadows");
    addAndMakeVisible(createCompButton);
    createCompButton.onClick = [this]()
    {
        createComponentAndShadows();
    };
    
    deleteCompButton.setButtonText("Delete Component 1");
    addAndMakeVisible(deleteCompButton);
    deleteCompButton.onClick = [this]()
    {
        deleteComponent();
    };
    
    forceResizeButton.setButtonText("Force a Resized");
    addAndMakeVisible(forceResizeButton);
    forceResizeButton.onClick = [this]()
    {
        resized();
    };
    
    createComp2Button.setButtonText("Create Component 2");
    addAndMakeVisible(createComp2Button);
    createComp2Button.onClick = [this]()
    {
        testComponent2.reset();
        testComponent2 = std::make_shared<FilledComponent>();
        addAndMakeVisible(*testComponent2);
        resized();
    };
}

MainComponent::~MainComponent()
{
}

//==============================================================================
void MainComponent::paint (juce::Graphics& g)
{
    // (Our component is opaque, so we must completely fill the background with a solid colour)
    g.fillAll (getLookAndFeel().findColour (juce::ResizableWindow::backgroundColourId));

}

void MainComponent::resized()
{
    createCompButton.setBounds(10, 10, 200, 20);
    deleteCompButton.setBounds(10, 40, 200, 20);
    forceResizeButton.setBounds(10, 70, 200, 20);
    createComp2Button.setBounds(10, 100, 200, 20);

    if (testComponent != nullptr)
        testComponent->setBounds(200, 200, 100, 100);
    if (testComponent2 != nullptr)
        testComponent2->setBounds(350, 200, 100, 100);
}

void MainComponent::createComponentAndShadows()
{
    testComponent.reset();
    testComponent = std::make_shared<FilledComponent>();
    addAndMakeVisible(*testComponent);
    dropShadow.setOwner(testComponent.get());
    resized();
}

void MainComponent::deleteComponent()
{
    if (testComponent != nullptr)
    {
        testComponent->setVisible(false);
        testComponent.reset();
    }
}
