#pragma once

#include <JuceHeader.h>


class FilledComponent : public juce::Component
{
public:
    FilledComponent() {}
    
    void paint(juce::Graphics &g) override { g.fillAll(juce::Colours::blue); }
};

//==============================================================================
/*
    This component lives inside our window, and this is where you should put all
    your controls and content.
*/
class MainComponent  : public juce::Component
{
public:
    //==============================================================================
    MainComponent();
    ~MainComponent() override;

    //==============================================================================
    void paint (juce::Graphics&) override;
    void resized() override;
    
    void createComponentAndShadows();
    void deleteComponent();

private:
    //==============================================================================
    // Your private member variables go here...

    juce::DropShadower dropShadow;
    std::shared_ptr<FilledComponent> testComponent = nullptr;
    std::shared_ptr<FilledComponent> testComponent2 = nullptr;

    juce::TextButton createCompButton;
    juce::TextButton deleteCompButton;
    juce::TextButton forceResizeButton;
    juce::TextButton createComp2Button;



    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MainComponent)
};
